
// DFPlayer mini MP3 audio playback module Arduino library for FLProg.
// rw6cm 22.11.2017

#ifndef __DFPlayerMega_h
#define	__DFPlayerMega_h
#include "HardwareSerial.h"
#include <SoftwareSerial.h>
#define uns8 unsigned char
#define uns16 unsigned int
//Command Types
#define DFPlayer_RESET	0x0C, 0x00
#define DFPlayer_NORMA	0x0B, 0x00

class DFPlayerMega 
{
private:
	HardwareSerial *myHardSerial;
	SoftwareSerial *mySoftSerial;
	void send_command(uns8 cmd, uns16 param);

public:
 
	void set_serial (HardwareSerial &theSerial);
	void set_serial (SoftwareSerial &theSerial);
	void normal_mode();
	void next_track();
	void previous_track();
	void start_track(uns8 folder, uns8 track);	//Track 0 - 254, folder 1-10
	void volume_up();
	void volume_down();
	void set_volume(uns16 volume);				//Volume 0 - 30, defaults 30
	void set_EQ(uns16 eq);						//EQ 0 - 5 defaults 0
	void set_replay(uns16 mode);	
	void pause();
	void repeat_play(uns16 repeat);
	void random_play();
};
#endif