// DFPlayer mini MP3 audio playback module Arduino library for FLProg.
// rw6cm 22.11.2017

#include <Arduino.h>
#include "DFPlayerMp3.h"


void DFPlayerMp3::init (HardwareSerial* theSerial) 
{
	mySerial = theSerial;
}

void DFPlayerMp3::sendCmd (uint8_t *cmd) 
{
	uint8_t checksum = 0;
	for (int i=2; i<8; i++) 
	{
		checksum += cmd[i];
	}
	cmd[8] = (uint8_t)~checksum;
	for (int i=0; i<10; i++) 
	{
		(*mySerial).write (cmd[i]);
	}
}

void DFPlayerMp3::play1() 
{
	static uint8_t play_cmd [10] = { 0x7E, 0xFF, 0x06, 0x0F, 0x00, 0x01, 0x01, 0xFE, 0xEA, 0xEF};
	sendCmd (play_cmd);
}
void DFPlayerMp3::play2() 
{
	static uint8_t play_cmd [10] = { 0x7E, 0xFF, 0x06, 0x0F, 0x00, 0x01, 0x02, 0xFE, 0xE9, 0xEF};
	sendCmd (play_cmd);
}
void DFPlayerMp3::play3() 
{
	static uint8_t play_cmd [10] = { 0x7E, 0xFF, 0x06, 0x0F, 0x00, 0x01, 0x03, 0xFE, 0xE8, 0xEF};
	sendCmd (play_cmd);
}
void DFPlayerMp3::play4() 
{
	static uint8_t play_cmd [10] = { 0x7E, 0xFF, 0x06, 0x0F, 0x00, 0x01, 0x04, 0xFE, 0xE7, 0xEF};
	sendCmd (play_cmd);
}
void DFPlayerMp3::play5() 
{
	static uint8_t play_cmd [10] = { 0x7E, 0xFF, 0x06, 0x0F, 0x00, 0x01, 0x05, 0xFE, 0xE6, 0xEF};
	sendCmd (play_cmd);
}
void DFPlayerMp3::play6() 
{
	static uint8_t play_cmd [10] = { 0x7E, 0xFF, 0x06, 0x0F, 0x00, 0x01, 0x06, 0xFE, 0xE5, 0xEF};
	sendCmd (play_cmd);
}
void DFPlayerMp3::play7() 
{
	static uint8_t play_cmd [10] = { 0x7E, 0xFF, 0x06, 0x0F, 0x00, 0x01, 0x07, 0xFE, 0xE4, 0xEF};
	sendCmd (play_cmd);
}
void DFPlayerMp3::play8() 
{
	static uint8_t play_cmd [10] = { 0x7E, 0xFF, 0x06, 0x0F, 0x00, 0x01, 0x08, 0xFE, 0xE3, 0xEF};
	sendCmd (play_cmd);
}
void DFPlayerMp3::play9() 
{
	static uint8_t play_cmd [10] = { 0x7E, 0xFF, 0x06, 0x0F, 0x00, 0x01, 0x09, 0xFE, 0xE2, 0xEF};
	sendCmd (play_cmd);
}
void DFPlayerMp3::play10() 
{
	static uint8_t play_cmd [10] = { 0x7E, 0xFF, 0x06, 0x0F, 0x00, 0x01, 0x0A, 0xFE, 0xE1, 0xEF};
	sendCmd (play_cmd);
}
void DFPlayerMp3::play11() 
{
	static uint8_t play_cmd [10] = { 0x7E, 0xFF, 0x06, 0x0F, 0x00, 0x01, 0x0B, 0xFE, 0xE0, 0xEF};
	sendCmd (play_cmd);
}
void DFPlayerMp3::play12() 
{
	static uint8_t play_cmd [10] = { 0x7E, 0xFF, 0x06, 0x0F, 0x00, 0x01, 0x0C, 0xFE, 0xDF, 0xEF};
	sendCmd (play_cmd);
}
void DFPlayerMp3::play13() 
{
	static uint8_t play_cmd [10] = { 0x7E, 0xFF, 0x06, 0x0F, 0x00, 0x01, 0x0D, 0xFE, 0xDE, 0xEF};
	sendCmd (play_cmd);
}
void DFPlayerMp3::play14() 
{
	static uint8_t play_cmd [10] = { 0x7E, 0xFF, 0x06, 0x0F, 0x00, 0x01, 0x0E, 0xFE, 0xDD, 0xEF};
	sendCmd (play_cmd);
}
void DFPlayerMp3::play15() 
{
	static uint8_t play_cmd [10] = { 0x7E, 0xFF, 0x06, 0x0F, 0x00, 0x01, 0x0F, 0xFE, 0xDC, 0xEF};
	sendCmd (play_cmd);
}
void DFPlayerMp3::play16() 
{
	static uint8_t play_cmd [10] = { 0x7E, 0xFF, 0x06, 0x0F, 0x00, 0x01, 0x10, 0xFE, 0xDB, 0xEF};
	sendCmd (play_cmd);
}
void DFPlayerMp3::play17() 
{
	static uint8_t play_cmd [10] = { 0x7E, 0xFF, 0x06, 0x0F, 0x00, 0x01, 0x11, 0xFE, 0xDA, 0xEF};
	sendCmd (play_cmd);
}
void DFPlayerMp3::play18() 
{
	static uint8_t play_cmd [10] = { 0x7E, 0xFF, 0x06, 0x0F, 0x00, 0x01, 0x12, 0xFE, 0xD9, 0xEF};
	sendCmd (play_cmd);
}
void DFPlayerMp3::play19() 
{
	static uint8_t play_cmd [10] = { 0x7E, 0xFF, 0x06, 0x0F, 0x00, 0x01, 0x13, 0xFE, 0xD8, 0xEF};
	sendCmd (play_cmd);
}
void DFPlayerMp3::play20() 
{
	static uint8_t play_cmd [10] = { 0x7E, 0xFF, 0x06, 0x0F, 0x00, 0x01, 0x14, 0xFE, 0xD7, 0xEF};
	sendCmd (play_cmd);
}


